#include <iostream>
#include <string>

using namespace std;

int main()
{
    int n,o,a,b,ab;
    cin>>n>>o>>a>>b>>ab;
    string res1="moguce";
    int res[n][4]={0};
    for(int i=0;i<n;i++)
    {
        string rec;
        cin>>rec;
        int broj;
        cin>>broj;
        if(rec=="O")
        {
            if(broj<=o)
            {
                res[i][0]=broj;
                o-=broj;
            }
            else
            {
                res1="nemoguce";
                break;
            }
        }
        else if(rec=="A")
        {
            if(broj<=a)
            {
                res[i][1]=broj;
                a-=broj;
            }
            else if(broj-a<=o)
            {
                res[i][1]=a;
                res[i][0]=broj-a;
                a=0;
                o-=broj-a;
            }
            else
            {
                res1="nemoguce";
                break;
            }
        }
        else if(rec=="B")
        {
            if(broj<=b)
            {
                res[i][2]=broj;
                b-=broj;
            }
            else if(broj-b<=o)
            {
                res[i][1]=b;
                res[i][0]=broj-b;
                b=0;
                o-=broj-b;
            }
            else
            {
                res1="nemoguce";
                break;
            }
        }
        else
        {
            if(broj<=ab)
            {
                res[i][3]=broj;
                ab-=broj;
            }
            else if(broj-ab<=a)
            {
                res[i][3]=ab;
                res[i][1]=broj-ab;
                ab=0;
                a-=broj-ab;
            }
            else if(broj-ab<=b)
            {
                res[i][3]=ab;
                res[i][2]=broj-ab;
                ab=0;
                a-=broj-ab;
            }
            else if(broj-ab<=o)
            {
                res[i][3]=ab;
                res[i][0]=broj-ab;
                ab=0;
                o-=broj-ab;
            }
            else if(broj-ab-a<=b)
            {
                res[i][3]=ab;
                res[i][1]=a;
                res[i][2]=broj-ab-a;
                ab=0;
                a=0;
                b-=broj-ab-a;
            }
            else if(broj-ab-a<=o)
            {
                res[i][3]=ab;
                res[i][1]=a;
                res[i][0]=broj-ab-a;
                ab=0;
                a=0;
                o-=broj-ab-a;
            }
            else if(broj-ab-b<=a)
            {
                res[i][3]=ab;
                res[i][2]=b;
                res[i][1]=broj-ab-b;
                ab=0;
                b=0;
                a-=broj-ab-b;
            }
            else if(broj-ab-b<=o)
            {
                res[i][3]=ab;
                res[i][2]=b;
                res[i][0]=broj-ab-o;
                ab=0;
                b=0;
                o-=broj-ab-b;
            }
            else if(broj-ab-o<=a)
            {
                res[i][3]=ab;
                res[i][0]=o;
                res[i][1]=broj-ab-o;
                ab=0;
                o=0;
                a-=broj-ab-o;
            }
            else if(broj-ab-o<=b)
            {
                res[i][3]=ab;
                res[i][0]=o;
                res[i][2]=broj-ab-o;
                ab=0;
                o=0;
                b-=broj-ab-o;
            }
            else if(broj-ab-b-o<=a)
            {
                res[i][0]=o;
                res[i][2]=b;
                res[i][3]=ab;
                res[i][1]=broj-ab-b-o;
                ab=0;
                o=0;
                b=0;
                a-=broj-ab-o-b;
            }
            else if(broj-ab-a-o<=b)
            {
                res[i][0]=o;
                res[i][1]=a;
                res[i][3]=ab;
                res[i][2]=broj-ab-a-o;
                ab=0;
                o=0;
                a=0;
                b-=broj-ab-o-a;
            }
            else if(broj-ab-a-b<=o)
            {
                res[i][1]=a;
                res[i][2]=b;
                res[i][3]=ab;
                res[i][0]=broj-ab-a-b;
                ab=0;
                a=0;
                b=0;
                o-=broj-ab-a-b;
            }
            else if(broj-ab-b-o-a==0)
            {
                res[i][0]=o;
                res[i][2]=b;
                res[i][3]=ab;
                res[i][1]=a;
                ab=0;
                o=0;
                b=0;
                a=0;
            }
            else
            {
                res1="nemoguce";
                break;
            }
        }
    }
    cout<<res1<<endl;
    if(res1=="moguce")
    {
        for(int i=0;i<n;i++)
        {
            for(int j=0;j<4;j++)
            {
                cout<<res[i][j]<<" ";
            }
            cout<<endl;
        }
    }
    return 0;
}